subroutine vox_mesh_fort(vmf,A, nx, ny, nz,x_cell,y_cell,z_cell,vfraction,lA)

implicit none

integer, intent(in) :: nx
integer, intent(in) :: ny
integer, intent(in) :: nz
integer, intent(in) :: lA
double precision, intent(in) :: vfraction
double precision, intent(in) :: x_cell
double precision, intent(in) :: y_cell
double precision, intent(in) :: z_cell
double precision, intent(in), dimension(lA,3,3) :: A
double precision, intent(out), dimension(nx,ny,nz) :: vmf
integer i
integer j
integer k
double precision phys_value
double precision phys_value_temp
integer l
double precision, dimension (3) :: X
double precision, dimension (3) :: XA
double precision, dimension (3) :: XB
double precision, dimension (3) :: XC
double precision alpha
double precision d
double precision lim_int
double precision lim_ext
double precision density
double precision material
double precision rlow
double precision rhigh
double precision radius
double precision tol
double precision resto
integer whole
material=0
whole=0
rlow=0
rhigh=0.5
tol=1.E-10
resto=1
radius=0
do while (resto .ge. tol)
material=0
whole=0
radius=((rlow+rhigh)/2.0)
!print *, "radius1=",radius
!print *, "density1=",density
iloop: do i=1,nx,1
jloop: do j=1,ny,1
kloop: do k=1,nz,1

X(1)=(i-1)*x_cell/nx+x_cell/(2*nx)
X(2)=(j-1)*y_cell/ny+y_cell/(2*ny)
X(3)=(k-1)*z_cell/nz+z_cell/(2*nz)
phys_value=0
l=1
do while (phys_value .ne. 1 .and. l .le. lA)
lim_int= radius-x_cell/(2*nx)
lim_ext= radius+x_cell/(2*nx)
XA(1)=X(1)
XA(2)=X(2)
XA(3)=X(3)
XB(1)=A(l,1,1)
XB(2)=A(l,1,2)
XB(3)=A(l,1,3)
XC(1)=A(l,2,1)
XC(2)=A(l,2,2)
XC(3)=A(l,2,3)
alpha = -((XC(1)-XB(1))*(XB(1)-XA(1))+(XC(2)-XB(2))*(XB(2)-XA(2))+(XC(3)-XB(3))*(XB(3)-XA(3))) &
/((XC(1)-XB(1))**2+(XC(2)-XB(2))**2+(XC(3)-XB(3))**2)
if (alpha .ge. 0 .and. alpha .le. 1) then
d=sqrt((XB(1)-XA(1)+alpha*(XC(1)-XB(1)))**2+(XB(2)-XA(2)+alpha &
*(XC(2)-XB(2)))**2+(XB(3)-XA(3)+alpha*(XC(3)-XB(3)))**2)
elseif (alpha .lt. 0) then
d=sqrt((XB(1)-XA(1))**2+(XB(2)-XA(2))**2+(XB(3)-XA(3))**2)
else
d=sqrt((XC(1)-XA(1))**2+(XC(2)-XA(2))**2+(XC(3)-XA(3))**2)
endif
if (d .le. lim_int) then 
phys_value =1
elseif (d .gt. lim_int .and. d .le. lim_ext) then
phys_value_temp = 1/(lim_int-lim_ext)*d-lim_ext/(lim_int-lim_ext)
if (phys_value_temp .gt. phys_value) then
phys_value=phys_value_temp
endif
endif
l=l+1
end do
vmf(i,j,k)=phys_value
material=material+phys_value
whole=whole+1
end do kloop
end do jloop
end do iloop
density=material/whole
resto= abs(vfraction-density)
if (density .gt. vfraction) then
rhigh= radius
elseif (density .lt. vfraction) then
rlow= radius
endif
!print *, "radius2=",rhigh
!print *, "radius1=",rlow
print *, "vf_calc=",density
end do
!print *, "radius2=",rhigh
!print *, "radius1=",rlow
print *, "vf_input=",vfraction
print *, "vf_final=",density
print *, "RADIUSf=",radius
open(99, file = 'Radius.dat', status = 'old')
write(99,*) radius
 close(99)
end subroutine vox_mesh_fort
