/**********************************************************************/
/** Copyright (C) 2021 - Université Catholique de Louvain		**/
/** secantmfh version 2021.1						**/
/** Author: Mohamed HADDAD (immc-MEMA)				**/
/** Contact: mohamed.haddad@uclouvain.be				**/
/** Use of this source code is governed by an UCL-style license	**/ 
/** All Rights Reserved						**/
/** This project has received funding from the European 		**/
/** Union’s Horizon 2020 research and innovation program		**/
/** under grant agreement No 862015					**/
/***********************************************************************/


#ifndef BOX_SECANT_H
#define BOX_SECANT_H 1

#include "matprop.h"
#include "state.h"

/** Resolution of the constitutive box in viscoelasto-viscoplasticity with the incremental secant formulation **/

int box_secant(MATPROP *material, STATE *tn, STATE *tn_res, MATPROP *material2, STATE *tn2, STATE *tn_res2,\
		 double timetn, double dt, double dt_unload, double *dstrn_r, double *dstrnmacro_r, STATE *tau,\
		 								 double **C_sec, double *Beta_sec );

int constbox_vevp(MATPROP *material, STATE *tn, STATE *tn_res, MATPROP *material2, STATE *tn2, STATE *tn_res2, double dt, \
					double dt_unload, double *dstrn_r, double *dstrnmacro_r, double *ftr, double *dstrs_r_tr,\
									 double *strs, double *p, double *pstrn, double *strs_eq2nd);

#endif
